/* testsome.c */
/* CUSTOM Fortran interface file */
#include "mpiimpl.h"

#ifdef POINTER_64_BITS
extern void *MPIR_ToPointer();
extern int MPIR_FromPointer();
extern void MPIR_RmPointer();
#else
#define MPIR_ToPointer(a) (a)
#define MPIR_FromPointer(a) (int)(a)
#define MPIR_RmPointer(a)
#endif

#ifdef MPI_BUILD_PROFILING
#ifdef FORTRANCAPS
#define mpi_testsome_ PMPI_TESTSOME
#elif defined(FORTRANDOUBLEUNDERSCORE)
#define mpi_testsome_ pmpi_testsome__
#elif !defined(FORTRANUNDERSCORE)
#define mpi_testsome_ pmpi_testsome
#else
#define mpi_testsome_ pmpi_testsome_
#endif
#else
#ifdef FORTRANCAPS
#define mpi_testsome_ MPI_TESTSOME
#elif !defined(FORTRANUNDERSCORE)
#define mpi_testsome_ mpi_testsome
#endif
#endif

 void mpi_testsome_( incount, array_of_requests, outcount, array_of_indices, 
    array_of_statuses, __ierr )
int*incount, *outcount, array_of_indices[];
MPI_Request array_of_requests[];
MPI_Status  array_of_statuses[];
int *__ierr;
{
int i;
*__ierr = MPI_Testsome(*incount,array_of_requests,outcount,
array_of_indices,array_of_statuses);
for (i=0; i<*outcount; i++) {
    if (array_of_indices[i] >= 0)
	array_of_indices[i] = array_of_indices[i] + 1;
    }
}
